unit form1;
//----------------------------------------------------------------------
// Translated from : form1.frm By Delux (c) on 20/12/2008 22:48:42
// Standard Edition  Version 2.05
// Manual editing by S R Woodall.
// Note : you will need the Pro Edition to translate database related code.
//----------------------------------------------------------------------
interface
uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, menus, extctrls, buttons, clipbrd;
Type
   TForm1Cls = class(TForm)
        Str : TEdit;
        Byte0 : TEdit;
        btnGetCount : TButton;
        btnClose : TButton;
        btnTransmit : TButton;
        btnOpen : TButton;
        Label2 : TLabel;
        Label1 : TLabel;
        Text1: TMemo;
        procedure btnGetCount_Click(Sender: TObject);
        procedure btnOpen_Click(Sender: TObject);
        procedure btnTransmit_Click(Sender: TObject);
        procedure btnClose_Click(Sender: TObject);
        procedure Form_Unload(Sender: TObject; var Action: TCloseAction);
     private
     public
   end;

type ArByte = array[0..31] of byte;
     ArChar = array[0..17] of char;
     PDWORD = ^DWord; //This is the conversion from VB !

var sID: ArChar = 'vid_12bf&pid_f030';

var
   Form1Cls : TForm1Cls;
   function ECIO_GetDLLVersion(): longint; stdcall; external 'ECIO_api.dll';
   function ECIO_Open(index: longint; pVID_PID: ArChar): longint;
                      stdcall; external 'ECIO_api.dll';
   function ECIO_Close(): longint; stdcall; external 'ECIO_api.dll';
   function ECIO_Transmit(pDataOut: ArByte;
                          dwLenOut: longint;
                          pActualLenOut: PDWORD;
                          pDataIn: ArByte;
                          dwExpectedLenIn: longint;
                          pActualLenIn: PDWORD;
                          dwTimeout: longint): longint;
                          stdcall; external 'ECIO_api.dll';
   function ECIO_GetDeviceCount(pVID_PID: ArChar): longint;
                                stdcall; external 'ECIO_api.dll';

   Const CR = Chr(13)+Chr(10);

implementation
{$R *.dfm}

procedure TForm1Cls.btnGetCount_Click(Sender: TObject);
var lCnt : longint;
begin
   lCnt := ECIO_GetDeviceCount(sID);
   Text1.text := Text1.text+'Count = '+IntToStr(lCnt)+CR;
end;

procedure TForm1Cls.btnOpen_Click(Sender: TObject);
var lRetVal : longint;
begin
   lRetVal := ECIO_Open(0, sID);
   Text1.text := Text1.text+'Open = '+IntToStr(lRetVal)+CR;
end;

procedure TForm1Cls.btnTransmit_Click(Sender: TObject );
var bDataIn : ArByte;
    bDataOut : ArByte;
    count : Byte;
    lRetVal : Longint;
    nRxDataCnt : Longint;
    nTxDataCnt : Longint;
    StrLen : Byte;
begin
   StrLen := length(Str.Text);
   if (StrLen > 31 ) then StrLen := 31;
   bDataOut[0] := StrToInt(Byte0.text);
   For count := 1  to StrLen  do
     begin bDataOut[count]:= Byte(Str.Text[count]); end;

//   StrBytes := VBA.StrConv( inttostr.text , vbFromUnicode );
//   For count := 0  to StrLen-1  do
//     begin  bDataOut[count+1] := StrBytes[count]; end;

   lRetVal := ECIO_Transmit( bDataOut,32,@nTxDataCnt,bDataIn,32,@nRxDataCnt,500);
   Text1.text := '';
   Text1.text := Text1.text+'Transmit return = '+IntToStr(lRetVal)+CR;
   Text1.text := Text1.text+'Transmit rxDataCnt = '+IntToStr(nRxDataCnt)+CR;
   Text1.text := Text1.text+'Transmit txDataCnt = '+IntToStr(nTxDataCnt)+CR;
   Text1.text := Text1.text+'Transmit bDataIn(0) = '+IntToStr(bDataIn[0])+CR;
   Text1.text := Text1.text+'Transmit bDataIn(1) = '+IntToStr(bDataIn[1])+CR;
   Text1.text := Text1.text+'Transmit bDataIn(2) = '+IntToStr(bDataIn[2])+CR;
   Text1.text := Text1.text+'Transmit bDataIn(3) = '+IntToStr(bDataIn[3])+CR;
   Text1.text := Text1.text+'Transmit bDataIn(4) = '+IntToStr(bDataIn[4])+CR;
   If bDataOut[0] = 3 then
     For count:= 0  to 4  do
     begin Text1.Text:= Text1.Text+Chr(bDataIn[count]) end;
   Text1.Text:= Text1.Text+CR;
end;

procedure TForm1Cls.btnClose_Click(Sender: TObject);
var
    lRetVal : Longint;
begin 
   lRetVal := ECIO_Close;
   Text1.text := Text1.text+'Close = '+IntToStr(lRetVal)+CR;
end;
 
procedure TForm1Cls.Form_Unload(Sender: TObject; var Action: TCloseAction);
begin 
     //Make sure the connection is closed
   ECIO_Close; 
end; 
 
end.
